text = {}
text.__index = text

function text.create( words, x, y, ti ) --s for segments you want to divide it into (i.e. 2 for drawing halves). t for speed betwwen divisions
	local t = {}
	t.hits = {}
	t.strings = {}
	t.widths = {}
	
	setmetatable( t, text )
	
	for i = 1, string.len( words ) do
		if #t.hits == 0 then
			hit = string.find( words, '\n' )
			str = string.sub( words, 1, hit )
		else
			hit = string.find( words, '\n', t.hits[#t.hits] + 1 )
			str = string.sub( words, t.hits[#t.hits] + 2, hit )
			if hit == nil then
				str = string.sub( words, t.hits[#t.hits] +2 )
				table.insert( t.strings, str )
				break
			end
		end
		table.insert( t.hits, hit )
		table.insert( t.strings, str )
	end
	
	t.words = words
	t.x = x
	t.y = y
	t.ti = ti
	
	t.time = 0
	
	t.visible = 1
	
	t.th = font:getHeight( words )
	t.h = #t.strings * t.th
	
	for i = 1, #t.strings do
		w = font:getWidth( t.strings[i] )
		table.insert( t.widths, w )
	end
	t.w = math.max( unpack( t.widths ) )
	
	return t
end

function text:draw()
	love.graphics.setColor( 255, 255, 255 )
	love.graphics.rectangle( 'fill', ( 800 - self.w ) / 2, self.y, self.w, self.th * self.visible )
	love.graphics.setColor( 0, 0, 0 )
	for i = 1, self.visible do
		love.graphics.print( self.strings[i], ( 800 - self.widths[i] ) / 2, ( self.y + self.th ) * i - self.th )
	end
end

function text:update(dt)
	self.time = self.time + dt
	if self.time >= self.ti then
		self.time = 0
		self.visible = self.visible + 1
		if self.visible > #self.strings then
			self.visible = #self.strings
		end
	end
end